VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cFormulas"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'----------------------------------------------------------------------------------
'cFormulas                                                              (06/Feb/99)
'   Clase para evaluar expresiones
'
'Guillermo 'guille' Som, 1999 <guille@costasol.net>
'----------------------------------------------------------------------------------
'Revisin del  7/Feb/99 Ahora se evaluan correctamente los operadores con ms
'                       precedencia, en este orden: % ^ * / \ + -
'                       Tambin se permiten parntesis no balanceados,
'                       al menos los de apertura.
'                       Si faltan los de cierre se aaden al final.
'                       Se permiten definir Funciones y usar algunas internas
'                       siempre que no necesiten parmetros (por ahora Rnd)
'Revisin del  9/Feb/99 Se pueden usar funciones internas con parmetros:
'                       Por ahora:
'                       Int, Fix, Abs, Sgn, Sqr, Cos, Sin, Tan, Atn, Exp, Log
'Revisin del  9/Feb/99 Se permiten funciones con un nmero variable de parmetros
'                       aunque las operaciones a realizar en los parmetros
'                       opcionales siempre sea la misma... algo es algo
'                       Se evala la expresin por si hay asignaciones a variables
'                       y de ser as, se crean esas variables y despus se evala
'                       el resto de la expresin.
'                       Esto permite crear variables en la misma cadena a evaluar,
'                       sin tener que asignarlas antes.
'                       Este ejemplo devolver el valor mayor de X o Y
'                       X = A+B : Y = C-X : Max(x,y)
'                       Las asignaciones NO se pueden hacer as:
'                       x:=10:y:=20:x+y (devolvera 0)
'                       Tambin permite cadenas de caracteres, aunque lo que haya
'                       entre comillas simplemente se repetir:
'                       x=10:y=20:"El mayor de x e y =";Max(x,y)
'                       Si se hace esto otro:
'                       x=10:y=20:s="El mayor de x e y =";Max(x,y):s
'                       Devolver:"El mayor de x e y ="20
'                       Ya que se evala como s=Max(x,y)
'                       Esto otro:
'                       x=10:y=20:s="El mayor de x e y =";z:z=Max(x,y)
'                       Mostrar:
'                       "El mayor de x e y ="
'                       Ya que se asigna s=z, pero no se muestra el valor de z
'                       RESUMIENDO:
'                       Se pueden usar cadenas entre comillas pero no se pueden
'                       asignar a variables... (al menos por ahora)
'                       Se puede incrementar una variable en una asignacin
'                       x=10:x=x+5+x sera igual a 10+5+10 = 25
'                       x=10:x=x+1 sera igual a 10+1 = 11
'Revisin del 10/Feb/99 Algunas correcciones de las cadenas y otras cosillas
'----------------------------------------------------------------------------------
' Esta es una nueva implementacin del mdulo Formula.bas y la clase cEvalOp
' Aunque los mtodos usados son totalmente diferentes y realmente no es una
' mejora, estn basados en dichos mdulos... o casi...
'
'Por el cdigo anterior: (c)Guillermo 'guille' Som, 1991-98
'----------------------------------------------------------------------------------
Option Explicit
Option Compare Text

' Funciones Internas soportadas en el programa,
' debe indicarse el parntesis y un espacio de separacin
Const FunVBNum As String = "Int( Fix( Abs( Sgn( Sqr( Cos( Sin( Tan( Atn( Exp( Log( "
' Smbolos a usar para separar los Tokens
Private Simbols As String
' Signos a usar para comentarios
Private RemSimbs As String

' Tipo para las variables
Private Type tVariable
    Name    As String
    Value   As String
End Type
' Array de variables
Private aVariables() As tVariable

' Tipo para las funciones
Private Type tFunctions
    Name        As String
    Params      As String
    Formula     As String
    'Descripcion As String
End Type
' Array de funciones
Private aFunctions() As tFunctions

Public Function MTrim(ByVal sVar As String, Optional ByVal NoEval As String = "") As String
    '------------------------------------------------------------------------------
    ' Quita todos los espacios y blancos del parmetro pasado           (09/Feb/99)
    ' Los parmetros:
    '   sVar    Cadena a la que se quitarn los blancos
    '   NoEval  Si se especifica, pareja de caracteres que encerrarn una cadena
    '           a la que no habr que quitar los espacios y blancos
    '------------------------------------------------------------------------------
    Dim i           As Long
    Dim j           As Long
    Dim sTmp        As String
    Dim sBlancos    As String

    
    ' Se entienden como blancos: espacios, Tabs y Chr$(0)
    sBlancos = " " & vbTab & Chr$(0)
    ' NoEval tendr el caracter que no se evaluar para quitar espacios
    ' por ejemplo si no queremos quitar los caracteres entre comillas
    ' NoEval ser chr$(34), e ir por pares o hasta el final de la cadena
    
    sTmp = ""
    For i = 1 To Len(sVar)
        ' Si es el caracter a no evaluar
        If Mid$(sVar, i, 1) = NoEval Then
            ' Buscar el siguiente caracter
            j = InStr(i + 1, sVar, NoEval)
            If j = 0 Then
                sVar = sVar & NoEval
                j = Len(sVar)
            End If
            sTmp = sTmp & Mid$(sVar, i, j - i + 1)
            i = j '+ 1
        ' Si no es uno de los caracteres "blancos"
        ElseIf InStr(sBlancos, Mid$(sVar, i, 1)) = 0 Then
            ' Asignarlo a la variable final
            sTmp = sTmp & Mid$(sVar, i, 1)
        End If
    Next
    MTrim = sTmp
End Function

Public Function AsignarVariables(ByVal v As String, _
                                 Optional ByVal NoEval As String = "") As String
    '------------------------------------------------------------------------------
    ' Asignar las variables, si las hay                                 (09/Feb/99)
    ' Los parmetros de entrada:
    '   v       Expresin con posibles asignaciones
    '   NoEval  Si se especifica, pareja de caracteres que encerrarn una cadena
    '           en la que no se buscarn variables
    '
    ' Devolver el resto de la cadena que ser la expresin a evaluar
    '------------------------------------------------------------------------------
    Dim i       As Long
    Dim j       As Long
    Dim k       As Long
    Dim sNom    As String
    Dim sVal    As String
    Dim sExpr   As String
    Dim sValAnt As String
    Dim sOp     As String
    
    ' Quitar todos los espacios, excepto los que estn entre comillas
    v = MTrim(v, NoEval)
    
    sExpr = ""
    ' Buscar los caracteres a no evaluar y ponerlos despus de las asignaciones
    If Len(NoEval) Then
        Do
            j = InStr(v, NoEval)
            ' Si hay caracteres a no evaluar
            If j Then
                ' Buscar el siguiente caracter NoEval y comprobar si despus
                ' hay asignaciones
                k = InStr(j + 1, v, NoEval)
                If k = 0 Then k = Len(v)
                sExpr = sExpr & Mid$(v, j, k - j + 1)
                v = Left$(v, j - 1) & Mid$(v, k + 1)
            End If
        Loop While j
    End If
    
    ' Buscar el signo de dos puntos que ser el separador,
    ' pero hay que tener en cuenta de que las asignaciones pueden ser con :=
    Do
        ' Buscar el siguiente signo igual
        i = InStr(v, "=")
        If i Then
            ' Lo que haya delante debe ser el nombre de la variable
            sNom = Left$(v, i - 1)
            ' Si sNom contiene : lo que haya antes de los dos puntos ser
            ' parte de la expresin y el resto ser el nombre.
            '*********************************************
            '***  Esto NO permite asignaciones con :=  ***
            '*********************************************
            j = InStr(sNom, ":")
            If j Then
                sExpr = sExpr & Left$(sNom, j - 1)
                sNom = Mid$(sNom, j + 1)
            End If
            ' Comprobar si a continuacin hay dos puntos,
            ' (ser el separador de varias asignaciones)
            j = InStr(i + 1, v, ":")
            ' Si no hay, tomar la longitud completa restante
            If j = 0 Then j = Len(v) + 1
            ' Asignar el valor desde el signo igual hasta los dos puntos
            ' (o el fin de la cadena, valor de j)
            sVal = Mid$(v, i + 1, j - (i + 1))
            ' Dejar en v el resto de la cadena
            v = Mid$(v, j + 1)
            ' Si ya no hay nada ms en la cadena, preparar para salir del Do
            If Len(v) = 0 Then i = 0
'            ' sNom puede ser Nombre: si se ha asignado con A:=expresin
'            If Right$(sNom, 1) = ":" Then
'                ' Quitarle los dos puntos
'                sNom = Left$(sNom, Len(sNom) - 1)
'            End If
            ' Comprobar si est en la lista de variables, si no est, aadirla
            j = IsVariable(sNom)
            If j Then
                ' Esta variable ya existe, sustituir la expresin
                '//////////////////////////////////////////////////////////////////
                ' Si en la expresin asignada est la misma variable
                ' sustituirla por el valor que tuviera
                sValAnt = aToken(sVal, sOp)
                If sValAnt = sNom Then
                    ' Sustituir la variable por el valor
                    sVal = aVariables(j).Value & sOp & sVal
                    'aVariables(j).Value = sVal
                    ' y calcularlo
                    sVal = ParseFormula(sVal)
                    sVal = Calcular(sVal)
                End If
                '//////////////////////////////////////////////////////////////////
                ' Asignar el valor asignado
                aVariables(j).Value = sVal
            Else
                ' No existe la variable, aadirla
                NewVariable sNom, sVal
            End If
        End If
    Loop While i
    ' Devolver el resto de la cadena, si queda algo...
    AsignarVariables = sExpr & v
End Function

Private Function aToken(ByRef sF As String, ByRef sSimbol As String) As String
    '------------------------------------------------------------------------------
    ' Devuelve el siguiente TOKEN y el Smbolo siguiente
    ' un Token es una variable, instruccin, funcin o nmero
    '
    ' Los parmetros se deben especificar por referencia ya que se modifican:
    '   sF          Cadena con la frmula o expresin a Tokenizar
    '   sSimbol     El smbolo u operador a usar
    ' Se devolver la cadena con lo hallado o una cadena vaca si no hay nada
    '------------------------------------------------------------------------------
    Dim i       As Long
    Dim j       As Long
    Dim sSimbs  As String
    
    ' Usar los smbolos normales y los usados para los comentarios
    ' Pero no usar el de comillas dobles para que se puedan usar cadenas...
    'sSimbs = Chr$(34) & " " & Simbols & RemSimbs & " "
    sSimbs = Simbols & RemSimbs & " " & Chr$(34) & " "
    'sSimbs = Simbols & RemSimbs & " "
    
    ' Si la cadena de entrada est vaca o slo tiene blancos
    If Len(Trim$(sF)) = 0 Then
        aToken = ""
        sF = ""
    Else
        j = MultInStr(sF, sSimbs, sSimbol)
        ' El valor devuelto ser el smbolo que est ms a la izquierda
        If j = 0 Then
            ' Devolver la cadena completa
            aToken = sF
            sF = ""
        Else
            ' Si hay algo entre dos comillas dobles devolverlo          (10/Feb/99)
            i = InStr(sF, Chr$(34))
            If i Then
                ' Buscar la siguiente
                j = InStr(i + 1, sF, Chr$(34))
                If j = 0 Then
                    sF = sF & Chr$(34)
                    j = Len(sF)
                End If
                aToken = Mid$(sF, i, j - i + 1)
                sF = Left$(sF, i - 1) & Mid$(sF, j + 1)
                sSimbol = ""
                Exit Function
            End If
            ' Devolver lo hallado hasta el token
            aToken = Left$(sF, j - 1)
            sF = Mid$(sF, j + Len(sSimbol))
            ' Si el nmero est en notacin cientfica xxxEyyy
            If Right$(aToken, 1) = "E" Then
                aToken = aToken & sSimbol & Left$(sF, 2)
                sF = Mid$(sF, 3)
                sSimbol = ""
            End If
        End If
    End If
End Function

Public Function MultInStr(ByVal String1 As String, ByVal String2 As String, _
                          Optional ByRef sSimb As String, Optional ByVal Start As Long = 1) As Long
    '------------------------------------------------------------------------------
    ' Siempre se especificarn los tres parmetros,
    ' opcionalmente, el ltimo ser la posicin de inicio o 1 si no se indica
    '
    ' Busca en la String1 cualquiera de los caracteres de la String2,
    ' devolviendo la posicin del que est ms a la izquierda.
    ' El parmetro sSep se pasar por referencia y en l se devolver
    ' el separador hallado.
    '
    ' En String2 se debern separar con espacios los caracteres a buscar
    '------------------------------------------------------------------------------
    Dim j           As Long
    Dim sTmp        As String
    ' La posicin con un valor menor
    Dim elMenor     As Long
    ' Caracter de separacin
    Const sSep      As String = " "
    
    ' Hacer un bucle entre cada uno de los valores indicados en String2
    elMenor = 0
    If Start <= Len(String1) Then
        String2 = Trim$(String2) & sSep
        ' Se buscarn todas las subcadenas de String2
        Do
            j = InStr(String2, sSep)
            If j Then
                sTmp = Left$(String2, j - 1)
                String2 = Mid$(String2, j + Len(sSep))
                If Len(sTmp) Then
                    j = InStr(Start, String1, sTmp)
                Else
                    j = 0
                End If
                If j Then
                    If elMenor = 0 Or elMenor > j Then
                        elMenor = j
                        sSimb = sTmp
                    End If
                    ' Si es la posicin de inicio, no habr ninguno menor
                    ' as que salimos del bucle
                    If elMenor = Start Then
                        String2 = ""
                    End If
                End If
            Else
                String2 = ""
            End If
        Loop While Len(String2)
    End If
    MultInStr = elMenor
End Function

Private Sub Class_Initialize()
    '------------------------------------------------------------------------------
    ' Iniciar algunos valores y algunas de las funciones internas del VB
    ' soportadas por esta clase, (ver la constante FunVBNum)
    '------------------------------------------------------------------------------
    Dim i       As Long
    Dim j       As Long
    Dim sName   As String
    Dim sFunVB  As String
    '
    ' Smbolos
    Simbols = ":= < > = >= <= ( ) ^ * / \ - + $ ! # @ { } [ ] "
    ' Comentarios
    RemSimbs = "; ' // "
    ' Inicializar el array con el elemento cero, que no se usar
    ReDim aVariables(0)
    ReDim aFunctions(0)
    
    '------------------------------------------------------------------------------
    ' Funciones con ms de un parmetro, incluso un nmero indefinido   (09/Feb/99)
    ' Los parmetros pueden ser cualquier tipo de expresin que esta clase evalue
    ' Cuando se usa ms de un parmetro, asegurarse de que son nombres distintos
    ' por ejemplo "Num, Num1" no funcionara
    '------------------------------------------------------------------------------
    ' Suma varios nmeros, admite uno o ms parmetros
    ' Suma dos nmeros, tambin admite slo un parmetro,
    ' Si se especifica uno, devuelve ese valor... luego no suma
    NewFunction "Sum", "Num1,Num2,...", "Num1+Num2+..."
    ' Resta nmeros
    NewFunction "Subs", "Num1,Num2,...", "Num1-Num2-..."
    ' Multiplica nmeros
    NewFunction "Mult", "Num1,Num2,...", "Num1*Num2*..."
    ' Las funciones que se van a evaluar de forma especial, se deben indicar con @
    ' aunque estas funciones deben estar previamente contempladas y slo se
    ' evaluan si est el cdigo dentro de la clase...
    ' Max, devuelve el valor mayor de los dos indicados
    NewFunction "Max", "Num1,Num2", "@Max(Num1,Num2)"
    ' Min, devuelve el valor menor de los dos indicados
    NewFunction "Min", "Num1,Num2", "@Min(Num1,Num2)"
    '******************************************************************************
    '*** ATENCION ***
    '****************
    ' Si se usa Max o Min dentro de Max o Min hay que usar el smbolo @
    ' Por ejemplo: (devolvera 20)
    ' Max(@Max(10,20),@Min(5,4))
    '******************************************************************************
    '
    ' Funcin Rnd del VB
    NewFunction "Rnd", "", "@Rnd"
    ' Aadir las declaradas en la constante FunVar
    ' Las funciones deben estar separadas por espacios y acabar con el (
    ' por ejemplo: "Int( Fix( "
    '
    sFunVB = FunVBNum
    Do
        i = InStr(sFunVB, "( ")
        If i Then
            sName = Left$(sFunVB, i - 1)
            sFunVB = Mid$(sFunVB, i + 2)
            NewFunction sName, "Num", "@" & sName & "(Num)"
        End If
    Loop While Len(sFunVB)
    ' Aadir otras para que sirvan de ejemplo
    ' No usar el signo @ si hacen uso de algunas de las definidas
    ' sino el resultado sera el de esa funcin... esto habr que arreglarlo...
    NewFunction "Sec", "Num", "1/Cos(Num)"
    NewFunction "CoSec", "Num", "1/Sin(Num)"
    NewFunction "CoTan", "Num", "1/Tan(Num)"
End Sub

Public Function IsVariable(ByVal sName As String) As Long
    '------------------------------------------------------------------------------
    ' Comprueba si es una variable,
    ' de ser as, devolver el ndice en el array de variables
    ' o cero si no se ha hallado.
    ' En caso de no hallar la variable, la aade con el valor cero
    '------------------------------------------------------------------------------
    Dim i       As Long
    Dim sVar    As String
    Dim sVal    As String
    
    sName = Trim$(sName)
    IsVariable = 0
    If Len(sName) Then
        For i = 1 To UBound(aVariables)
            If aVariables(i).Name = sName Then
                IsVariable = i
                Exit For
            End If
        Next
    End If
    ' Si no existe la variable
    ' No se hace nada, que es lo mismo que si no existiera...           (09/Feb/99)
'    If IsVariable = 0 Then
'        ' y no es un nmero
'        If Len(sName) Then
'            If Not IsNumeric(sName) Then
''                ' Este caso ya no se dar, pero por si las moscas       (08/Feb/99)
''                sVar = sName
''                If Right$(sName, 1) = "E" Then
''                    sName = sName & "-02"
''                End If
''                ' Por si es un nmero con E
''                BuscarCifra sName, sVal
''                NewVariable sVar, sVal
'                NewVariable sName, "0"
'                IsVariable = UBound(aVariables)
'            End If
'        End If
'    End If
End Function

Public Function IsFunction(ByVal sName As String) As Long
    '------------------------------------------------------------------------------
    ' Comprueba si es una funcin,
    ' de ser as, devolver el ndice en el array de frmulas
    ' o cero si no se ha hallado
    '------------------------------------------------------------------------------
    Dim i As Long
    
    sName = Trim$(sName)
    IsFunction = 0
    If Len(sName) Then
        For i = 1 To UBound(aFunctions)
            If aFunctions(i).Name = sName Then
                IsFunction = i
                Exit For
            End If
        Next
    End If
End Function

Public Function FunctionVal(ByVal sName As String) As String
    '------------------------------------------------------------------------------
    ' Comprueba si sName contiene una frmula interna
    ' Estar en el formato: @FormulaInterna
    ' Slo ser vlido para funciones que no necesiten parmetros
    ' Ahora se permite un parmetro en las funciones soportadas         (08/Feb/99)
    '------------------------------------------------------------------------------
    Dim i           As Long
    Dim sValue      As String
    Dim sParams     As String
    Dim sNameFun    As String
    
    sName = Trim$(sName)
    i = InStr(sName, "@")
    If i Then
        sValue = Left$(sName, i - 1) & Mid$(sName, i + 1)
        ' Si es Rnd
        i = InStr(sValue, "Rnd")
        ' El formato ser Rnd [* valor]
        If i Then
            sName = Left$(sValue, i - 1) & "(" & Rnd & ")" & Mid$(sValue, i + 3)
        End If
        '//////////////////////////////////////////////////////////////////////////
        ' Si es alguna de las definidas en la constante FunVBNum
        ' sNameFun devolver el nombre de la funcin hallada
        i = MultInStr(sValue, FunVBNum, sNameFun)
        ' El formato ser NombreFuncin(expresin)
        If i Then
            sName = Mid$(sValue, i + 3)
            sParams = Parametros(sName)
            ' Calcular los parmetros
            sParams = Calcular(sParams)
            ' Convertir el parmetro para usar con estas funciones numricas
            Select Case sNameFun
            Case "Int("
                sParams = Int(sParams)
            Case "Fix("
                sParams = Fix(sParams)
            Case "Abs("
                sParams = Abs(sParams)
            Case "Sgn("
                sParams = Sgn(sParams)
            Case "Sqr("
                sParams = Sqr(sParams)
            Case "Cos("
                sParams = Cos(sParams)
            Case "Sin("
                sParams = Sin(sParams)
            Case "Tan("
                sParams = Tan(sParams)
            Case "Atn("
                sParams = Atn(sParams)
            Case "Exp("
                sParams = Exp(sParams)
            Case "Log("
                sParams = Log(sParams)
            End Select
            sName = "(" & sParams & ")" & sName
        Else
            ' Algunas otras que se evaluarn aqu
            ' deben estar declaradas con @
            i = MultInStr(sValue, "Max( Min( ", sNameFun)
            ' El formato ser Max(Num1, Num2)
            If i Then
                On Local Error Resume Next
                
                sName = Mid$(sValue, i + 3)
                sParams = Parametros(sName)
                i = InStr(sParams, ",")
                If i Then
                    sValue = Left$(sParams, i - 1)
                    sParams = Mid$(sParams, i + 1)
                    sValue = ParseFormula(sValue)
                    sParams = ParseFormula(sParams)
                    sValue = Calcular(sValue)
                    sParams = Calcular(sParams)
                    If sNameFun = "Max(" Then
                        sName = IIf(CDbl(sValue) > CDbl(sParams), sValue, sParams)
                    ElseIf sNameFun = "Min(" Then
                        sName = IIf(CDbl(sValue) < CDbl(sParams), sValue, sParams)
                    End If
                    If Err Then
                        sName = "Error: hay que usarla con @ o alguna variable no est definida"
                    End If
                    On Local Error GoTo 0
                    Err = 0
                Else
                    sName = sParams
                End If
            End If
        End If
        '//////////////////////////////////////////////////////////////////////////
    End If
    FunctionVal = sName
End Function

Public Function VariableVal(ByVal sName As String) As String
    '------------------------------------------------------------------------------
    ' Comprueba si es una variable,
    ' de ser as, devolver el contenido o valor de esa variable
    '
    ' Las variables estarn en un array
    '------------------------------------------------------------------------------
    Dim i       As Long
    Dim sValue  As String
    
    sName = Trim$(sName)
    sValue = ""
    If Len(sName) Then
        For i = 1 To UBound(aVariables)
            If aVariables(i).Name = sName Then
                sValue = aVariables(i).Value
                Exit For
            End If
        Next
    End If
    VariableVal = sValue
End Function

Public Sub NewFunction(ByVal sName As String, ByVal sParams As String, ByVal sFormula As String)
    '------------------------------------------------------------------------------
    ' Asigna una nueva funcin al array de funciones
    ' Los parmetros sern el nombre, los parmetros y la frmula a usar
    '
    ' Si la funcin indicada ya existe, se sustituirn los valores especificados
    '------------------------------------------------------------------------------
    Dim i           As Long
    Dim Hallado     As Boolean
    Dim NumF        As Long
    
    sName = Trim$(sName)
    sParams = Trim$(sParams)
    sFormula = Trim$(sFormula)
    
    NumF = UBound(aFunctions)
    Hallado = False
    ' Comprobar si la variable ya existe
    For i = 1 To NumF
        ' Si es as, asignar el nuevo valor
        If aFunctions(i).Name = sName Then
            aFunctions(i).Params = sParams
            aFunctions(i).Formula = sFormula
            Hallado = True
            Exit For
        End If
    Next
    ' Si no se ha hallado la funcin, aadirla
    If Not Hallado Then
        NumF = NumF + 1
        ReDim Preserve aFunctions(0 To NumF)
        With aFunctions(NumF)
            .Name = sName
            .Params = sParams
            .Formula = sFormula
        End With
    End If
End Sub

Public Sub NewVariable(ByVal sName As String, ByVal sValue As String)
    '------------------------------------------------------------------------------
    ' Asigna una nueva variable al array de variables
    ' Los parmetros sern el nombre y el valor
    '
    ' Si la variable indicada ya existe, se sustituir el valor por el indicado
    '------------------------------------------------------------------------------
    Dim i           As Long
    Dim Hallado     As Boolean
    Dim NumVars     As Long
    
    sName = Trim$(sName)
    sValue = Trim$(sValue)
    
    NumVars = UBound(aVariables)
    Hallado = False
    ' Comprobar si la variable ya existe
    For i = 1 To NumVars
        ' Si es as, asignar el nuevo valor
        If aVariables(i).Name = sName Then
            aVariables(i).Value = sValue
            Hallado = True
            Exit For
        End If
    Next
    ' Si no se ha hallado la variable, aadir una nueva
    If Not Hallado Then
        NumVars = NumVars + 1
        ReDim Preserve aVariables(0 To NumVars)
        With aVariables(NumVars)
            .Name = sName
            .Value = sValue
        End With
    End If
End Sub

Public Function ParseFormula(ByVal sF As String) As String
    '------------------------------------------------------------------------------
    ' Analiza la frmula indicada, sustituyendo las variables y funciones
    ' por sus valores, despus habr que calcular el resultado devuelto.
    ' En esta funcin se analizan las variables y funciones, dejando el valor
    ' que devolveran.
    ' Si la variable o funcin tiene otras variables o funciones se analizan
    ' y se ponen los valores devueltos.
    '------------------------------------------------------------------------------
    Dim i               As Long
    Dim j               As Long
    Dim k               As Long
    Dim n               As Long
    Dim qFuncion        As Long
    Dim sFormula        As String
    Dim sToken          As String
    Dim sOp             As String
    Dim sVar            As String
    Dim sParams         As String
    Dim sFunFormula     As String
    Dim sParamF         As String       ' Parmetro en la frmula
    Dim sParamE         As String       ' Parmetro en la expresin
    Dim sParamX         As String       ' Para aadir parmetros a la frmula
    
    Do
        ' Asignar a sToken el siguiente elemento a procesar
        sOp = ""
        sToken = aToken(sF, sOp)
        ' Si no es una funcin ni una variable, usar el valor indicado
        If Len(sToken) Then
            ' Si no es una variable o funcin
            If Not IsFuncOrVar(sToken) Then
                sFormula = sFormula & sToken & sOp
            Else
                ' Comprobar si el Token es una variable,
                ' si es as sustituirla por el valor
                sVar = VariableVal(sToken)
                If Len(sVar) Then
                    ' Comprobar si la variable contiene otras variables
                    ' o funciones
                    sVar = ParseFormula(sVar)
                    ' Asigna a sToken el valor obtenido
                    sToken = Calcular(sVar)
                End If
                ' Comprobar si el Token es una funcin
                qFuncion = IsFunction(sToken)
                ' Si es una funcin, qFuncion tiene el ndice de la funcin
                If qFuncion Then
                    ' Asignar los parmetros que usa la funcin
                    ' (en principio slo se admite un parmetro)
                    sVar = aFunctions(qFuncion).Params
                    ' La frmula a usar para esta funcin
                    sFunFormula = aFunctions(qFuncion).Formula
                    ' Si admite parmetros
                    If Len(sVar) Then
                        '//////////////////////////////////////////////////////////
                        ' Usar la funcion Parametros para analizar los prmetros
                        '//////////////////////////////////////////////////////////
                        If sOp = "(" Then
                            sF = sOp & sF
                            sParams = Parametros(sF)
                            If Len(sParams) Then
                                sOp = ""
                            End If
                        End If
                        '//////////////////////////////////////////////////////////
                        If Len(sParams) Then
                            ' Comprobar si los parmetros contienen alguna variable
                            ' u otra funcin
                            sParams = ParseFormula(sParams)
                            '
                            ' Sustituir los parmetros por los indicados en la frmula
                            ' (en principio slo se admite uno)
                            ' Sustituir en la frmula el nombre de la variable
                            ' por el parmetro
                            '
                            ' Si slo tiene un parmetro
                            If InStr(sVar, ",") = 0 Then
                                Do
                                    i = InStr(sFunFormula, sVar)
                                    If i Then
                                        ' Poner los parmetros dentro de parntesis
                                        sFunFormula = Left$(sFunFormula, i - 1) & "(" & sParams & ")" & Mid$(sFunFormula, i + Len(sVar))
                                    End If
                                Loop While i
                            Else
                                ' Resolver los parmetros
                                ' sParams tiene los parmetros a evaluar
                                ' sVar tiene los nombres de los parmetros
                                sVar = sVar & ","
                                sParams = sParams & ","
                                If InStr(sFunFormula, "...") Then
                                    ' Contar el nmero de parmetros que se han pasado
                                    ' para el caso de parmetros opcionales (se usan ...)
                                    i = 0
                                    For j = 1 To Len(sParams)
                                        If Mid$(sParams, j, 1) = "," Then i = i + 1
                                    Next
                                    ' Para convertir los parmetros opcionales
                                    ' en variables que despus se puedan sustituir.
                                    ' Las variables deben ser diferentes.
                                    sParamX = "NumX1"
                                    n = 0
                                    ' Obtener el ltimo parmetro de la frmula
                                    sParamF = Right$(sFunFormula, 4)
                                    sFunFormula = Left$(sFunFormula, Len(sFunFormula) - 4)
                                    sVar = Left$(sVar, Len(sVar) - 5)
                                    Do
                                        k = 0
                                        For j = 1 To Len(sVar)
                                            If Mid$(sVar, j, 1) = "," Then k = k + 1
                                        Next
                                        If i > k + 1 Then
                                            ' Buscar el ltimo de sVar
                                            For j = Len(sVar) - 1 To 1 Step -1
                                                If Mid$(sVar, j, 1) = "," Then
                                                    sVar = sVar & "," & sParamX & CStr(n)
                                                    sFunFormula = sFunFormula & Left$(sParamF, 1) & sParamX & CStr(n)
                                                    n = n + 1
                                                    Exit For
                                                End If
                                            Next
                                        End If
                                    Loop While i > k + 1
                                    If Right$(sVar, 1) <> "," Then sVar = sVar & ","
                                End If
                                '
                                Do
                                    j = InStr(sVar, ",")
                                    If j Then
                                        sParamF = Trim$(Left$(sVar, j - 1))
                                        sVar = Trim$(Mid$(sVar, j + 1))
                                        i = InStr(sParams, ",")
                                        If i Then
                                            sParamE = Trim$(Left$(sParams, i - 1))
                                            sParams = Trim$(Mid$(sParams, i + 1))
                                        Else
                                            sParamE = sParams
                                            sParams = ""
                                        End If
                                        ' Reemplazar sParamF por el parmetro
                                        Do
                                            i = InStr(sFunFormula, sParamF)
                                            If i Then
                                                ' Poner los parmetros dentro de parntesis
                                                sFunFormula = Left$(sFunFormula, i - 1) & "(" & sParamE & ")" & Mid$(sFunFormula, i + Len(sParamF))
                                            End If
                                        Loop While i
                                    End If
                                Loop While j
                            End If
                        End If
                    End If
                    ' Si tiene @FuncionInterna
                    ' usar esa funcin
                    sVar = ""
                    sVar = FunctionVal(sFunFormula)
                    If Len(sVar) Then
                        sFunFormula = ParseFormula(sVar)
                    End If
                    'sFormula = sFormula & Calcular(sFunFormula & sOp & sF)
                    If sOp <> Chr$(34) Then
                        sFunFormula = sFunFormula & sOp & sF
                        sFunFormula = ParseFormula(sFunFormula)
                        sFormula = sFormula & Calcular(sFunFormula)
                        sF = ""
                    Else
                        sFormula = sFormula & Calcular(sFunFormula)
                        sFormula = sFormula & sOp & sF
                        sF = ""
                    End If
                Else
                    sFormula = sFormula & sToken & sOp
                End If
            End If
        Else
            sFormula = sFormula & sToken & sOp
        End If
        '
    Loop While Len(sF)
    ' Devolver la expresin lista para calcular el valor
    ParseFormula = sFormula
End Function

Public Function Calcular(ByVal sFormula As String) As String
    '------------------------------------------------------------------------------
    ' Calcula el resultado de la expresin que entra en sFormula        (22/Oct/91)
    ' Modificado por la cuenta de la vieja...                     (01.12  7/May/93)
    ' Revisado para usar con cFormulas                                  (06/Feb/99)
    '------------------------------------------------------------------------------
    Dim i               As Long
    Dim j               As Long
    Dim k               As Long
    Dim j1              As Long
    Dim k1              As Long
    Dim n               As Long
    Dim pn              As Long
    Dim n1              As Double
    Dim n2              As Double
    Dim n3              As Double
    Dim Operador        As String
    Dim Cifra1          As String
    Dim Cifra2          As String
    Dim strP            As String
    Dim sOperadores     As String
    ' Estos son los smbolos a buscar para el operador anterior
    ' se deben incluir los parntesis ya que estos separan precedencias
    Const cOperadores   As String = "%^*/\+-()"
    '
    ' Quitarle los espacios extras
    sFormula = Trim$(sFormula)
    '
    '//////////////////////////////////////////////////////////////////////////////
    ' Para analizar siguiendo las operaciones de ms "peso",            (07/Feb/99)
    ' se buscarn operaciones en este orden % ^ * / \ + -
    ' y si se encuentran, se incluirn entre parntesis para que se procesen
    ' antes que el resto:
    ' 25 + 100 * 3 se convertira en: 25 + (100 * 3)
    '
    ' Buscar cada uno de los operadores y aadir los parntesis necesarios
    ' No se incluyen la suma y resta ya que son las que menos peso tienen
    sOperadores = "% ^ * / \ "
    ' Slo procesar si tiene uno de los operadores
    If MultInStr(sFormula, sOperadores, Operador) Then
        Cifra1 = sFormula
        n = Len(Cifra1)
        For i = 1 To Len(sOperadores) Step 2
            Operador = Mid$(sOperadores, i, 1)
            ' Se debera buscar de atrs para delante
            ' (ya se busca)
            pn = RInStr(n, Cifra1, Operador)
            If pn Then
                ' Tenemos ese operador
                ' buscar el signo anterior
                k = 0
                For j = pn - 1 To 1 Step -1
                    k = InStr(cOperadores, Mid$(Cifra1, j, 1))
                    If k Then
                        ' Slo procesar si el signo anterior es diferente de )
                        If Mid$(cOperadores, k, 1) <> ")" Then
                            ' Buscar el signo siguiente
                            k1 = 0
                            For j1 = pn + 1 To Len(Cifra1)
                                k1 = InStr(cOperadores, Mid$(Cifra1, j1, 1))
                                If k1 Then
                                    ' Aadirle los parntesis
                                    ' Si se multiplica por un nmero negativo
                                    k = MultInStr(Cifra1, "*- /- \- ")
                                    If k Then
                                        Cifra1 = Left$(Cifra1, j) & "(" & Mid$(Cifra1, j + 1, j1 - j - 2) & ")" & Mid$(Cifra1, k)
                                    Else
                                        If Right$(Mid$(Cifra1, j + 1, j1 - j - 1) & ")" & Mid$(Cifra1, j1, 1), 3) = "*)(" Then
                                            Cifra1 = Left$(Cifra1, j) & "(" & Mid$(Cifra1, j + 1, j1 - j - 2) & Mid$(Cifra1, j1 - 1) & ")"
                                        Else
                                            Cifra1 = Left$(Cifra1, j) & "(" & Mid$(Cifra1, j + 1, j1 - j - 1) & ")" & Mid$(Cifra1, j1)
                                        End If
                                    End If
                                    Exit For
                                End If
                            Next
                            ' Si no hay ningn signo siguiente
                            If k1 = 0 Then
                                Cifra1 = Left$(Cifra1, j) & "(" & Mid$(Cifra1, j + 1) & ")"
                            End If
                        End If
                        Exit For
                    End If
                Next
                pn = RInStr(n, Cifra1, Operador)
                n = pn - 1
                i = i - 2
            End If
        Next
        sFormula = Cifra1
    End If
    '
    '//////////////////////////////////////////////////////////////////////////////
    '
    ' Buscar parntesis e ir procesando las expresiones.
    Do While InStr(sFormula, "(")
        pn = InStr(sFormula, ")")
        ' Si hay parntesis de cierre
        If pn Then
            For i = pn To 1 Step -1
                If Mid$(sFormula, i, 1) = "(" Then
                    ' Calcular lo que est entre parntesis
                    strP = Mid$(sFormula, i + 1, pn - i - 1)
                    strP = Calcular(strP)
                    sFormula = Left$(sFormula, i - 1) & strP & Mid$(sFormula, pn + 1)
                    Exit For
                End If
            Next
        Else
            sFormula = sFormula & ")"
        End If
    Loop
    
    ' Si la frmula a procesar tiene algn operador
    sOperadores = "% ^ * / \ + - "
    If MultInStr(sFormula, sOperadores, Operador) Then
        Operador = ""
        Cifra1 = ""
        Cifra2 = ""
        Do
            ' Buscar la primera cifra
            If Len(sFormula) Then
                If Cifra1 = "" Then
                    BuscarCifra sFormula, Cifra1
                End If
                Operador = Left$(sFormula, 1)
                sFormula = Mid$(sFormula, 2)
                ' Buscar la segunda cifra
                BuscarCifra sFormula, Cifra2
                '
                n1 = 0
                If Len(Cifra1) Then
                    n1 = CDbl(Cifra1)
                End If
                ' Esto es necesario por si no se ponen los parntesis de apertura
                n2 = 0
                If Len(Cifra2) Then
                    n2 = CDbl(Cifra2)
                End If
                ' Efectuar el clculo
                Select Case Operador
                Case "+"
                    n3 = n1 + n2
                Case "-"
                    n3 = n1 - n2
                Case "*"
                    n3 = n1 * n2
                ' Si se divide por cero, se devuelve cero en lugar de dar error
                Case "/"
                    If n2 <> 0# Then
                        n3 = n1 / n2
                    Else
                        n3 = 0#
                    End If
                Case "\"
                    If n2 <> 0# Then
                        n3 = n1 \ n2
                    Else
                        n3 = 0#
                    End If
                Case "^"
                    n3 = n1 ^ n2
                ' Clculo de porcentajes:
                ' 100 % 25 = 25 (100 * (25 / 100))
                Case "%"
                    n3 = n1 * (n2 / 100#)
                ' Si es comillas dobles, no evaluar
                Case Chr$(34)
                    ' Calcular el resto despus de las comillas
                    i = InStr(sFormula, Chr$(34))
                    If i Then
                        Cifra1 = Mid$(sFormula, i + 1)
                        sFormula = Operador & Left$(sFormula, i)
                        Operador = ""
                        sFormula = sFormula & Calcular(Cifra1)
                        Calcular = sFormula
                        Exit Function
                    Else
                        sFormula = Operador & sFormula
                        Operador = ""
                        Calcular = sFormula
                        Exit Function
                    End If
                ' Si no es una operacin reconocida, devolver la suma,
                ' ya que esto puede ocurrir con los valores asignados a variables
                Case Else
                    ' Por si se incluye una palabra que no est declarada
                    ' (variable o funcin)
                    If Len(Cifra1 & Cifra2) Then
                        If Len(Cifra1) = 0 Then
                            Cifra1 = "0"
                        End If
                        If Len(Cifra2) = 0 Then
                            Cifra2 = "0"
                        End If
                        n3 = CDbl(Cifra1) + CDbl(Cifra2)
                    Else
                        n3 = 0
                    End If
                End Select
                Cifra1 = CStr(n3)
            Else
                Exit Do
            End If
        Loop While Operador <> ""
        Calcular = CStr(n3)
    Else
        ' Si no tiene ningn operador, devolver la frmula
        ' Habra que quitarle los carcteres extraos                    (10/Feb/99)
        If Left$(sFormula, 1) <> Chr$(34) Then
            sOperadores = "0123456789,."
            Cifra1 = ""
            For i = 1 To Len(sFormula)
                If InStr(sOperadores, Mid$(sFormula, i, 1)) Then
                    Cifra1 = Cifra1 & Mid$(sFormula, i, 1)
                End If
            Next
            sFormula = Cifra1
        End If
        Calcular = sFormula
    End If
End Function

Public Function RInStr(ByVal v1 As Variant, ByVal v2 As Variant, _
                        Optional ByVal v3 As Variant) As Long
    '------------------------------------------------------------------------------
    ' Devuelve la posicin de v2 en v1, empezando por atrs
    '------------------------------------------------------------------------------
    Dim i       As Long
    Dim posIni  As Long
    Dim sTmp    As String
    Dim s1      As String
    Dim s2      As String
    
    If IsMissing(v3) Then
        ' Si no se especifican los tres parmetros
        s1 = CStr(v1)       ' La primera cadena
        s2 = CStr(v2)       ' la segunda cadena
        posIni = Len(s1)    ' el ltimo caracter de la cadena
    Else
        posIni = CLng(v1)   ' la posicin por la que empezar
        s1 = CStr(v2)       ' la primera cadena (segundo parmetro)
        s2 = CStr(v3)       ' la segunda cadena (tercer parmetro)
    End If
    ' Valor inicial de la bsqueda, si no se encuentra, es cero
    RInStr = 0
    ' Siempre se empieza a buscar por el final
    For i = posIni - Len(s2) + 1 To 1 Step -1
        ' Tomar el nmero de caracteres que tenga la segunda cadena
        sTmp = Mid$(s1, i, Len(s2))     ' Si son iguales...
        If sTmp = s2 Then               ' esa es la posicin
            RInStr = i
            Exit For
        End If
    Next
End Function

Private Sub BuscarCifra(ByRef Expresion As String, ByRef Cifra As String)
    '------------------------------------------------------------------------------
    ' Buscar en Expresion una cifra                                ( 5 / 10/May/93)
    ' Devuelve la cifra y el resto de la expresin
    '------------------------------------------------------------------------------
    Const OPERADORES    As String = "+-*/\^%"
    Const CIFRAS        As String = "0123456789., "
    Const POSITIVO      As Long = 1&
    Const NEGATIVO      As Long = -1&
    
    Dim Signo           As Long
    Dim ultima          As Long
    Dim i               As Long
    Dim n               As String
    Dim sCifras         As String
    Dim sSigno          As String
    
    ' Quitar los espacios del principio
    Expresion = LTrim$(Expresion)
    
    ' Capturar errores por si se usan varios parmetros
    On Local Error Resume Next
    
    ' Evaluar slo si no est entre comillas
    If Left$(Expresion, 1) <> Chr$(34) Then
        Signo = POSITIVO                    'Comprobar si es un nmero negativo
        If Left$(Expresion, 1) = "-" Then
            Signo = NEGATIVO
            Expresion = Mid$(Expresion, 2)
        End If
        
        ultima = 0
        n = ""
        For i = 1 To Len(Expresion)
            If InStr(CIFRAS, Mid$(Expresion, i, 1)) Then
                n = n + Mid$(Expresion, i, 1)
                ultima = i
            Else
                Exit For
            End If
        Next i
        ' El val funciona slo si el decimal es el punto,
        ' cuando es una coma toma slo la parte entera
        If Len(n) Then
            ' Convertir adecuadamente los decimales
            n = ConvDecimal(n)
            Cifra = CStr((n) * Signo)
        Else
            Cifra = ""
        End If
        Expresion = LTrim$(Mid$(Expresion, ultima + 1))
        If Left$(Expresion, 1) = "E" Then
            ultima = Val(Mid$(Expresion, 3))
            sSigno = Mid$(Expresion, 2, 1)
            n = ""
            For i = 1 To ultima
                n = n & "0"
            Next
            n = "1" & n
            If sSigno = "-" Then
                Cifra = (Cifra) / (n)
            Else
                Cifra = (Cifra) * (n)
            End If
            Expresion = Mid$(Expresion, 5)
        End If
    End If
    On Local Error GoTo 0
    Err = 0
End Sub

Public Function ConvDecimal(ByVal strNum As String, _
                            Optional ByRef sDecimal As String = ",", _
                            Optional ByRef sDecimalNo As String = ".") As String
    '------------------------------------------------------------------------------
    ' Asigna el signo decimal adecuado (o lo intenta)                   (10/Ene/99)
    ' Devuelve una cadena con el signo decimal del sistema
    '------------------------------------------------------------------------------
    Dim i           As Long
    Dim j           As Long
    Dim sNumero     As String
    
    ' Averiguar el signo decimal
    sNumero = Format$(25.5, "#.#")
    If InStr(sNumero, ".") Then
        sDecimal = "."
        sDecimalNo = ","
    Else
        sDecimal = ","
        sDecimalNo = "."
    End If
    
    strNum = Trim$(strNum)
    If Left$(strNum, 1) = sDecimalNo Then
        Mid$(strNum, 1, 1) = sDecimal
    End If
    
    ' Si el nmero introducido contiene signos no decimales
    j = 0
    i = 1
    Do
        i = InStr(i, strNum, sDecimalNo)
        If i Then
            j = j + 1
            i = i + 1
        End If
    Loop While i
    
    If j = 1 Then
        ' Cambiar ese smbolo por un espacio, si slo hay uno de esos signos
        i = InStr(strNum, sDecimalNo)
        If i Then
            If InStr(strNum, sDecimal) Then
                Mid$(strNum, i, 1) = " "
            Else
                Mid$(strNum, i, 1) = sDecimal
            End If
        End If
    Else
        ' En caso de que tenga ms de uno de estos smbolos
        ' convertirlos de manera adecuada.
        ' Por ejemplo:
        ' si el signo decimal es la coma:
        '   1,250.45 sera 1.250,45 y quedara en 1250,45
        ' si el signo decimal es el punto:
        '   1.250,45 sera 1,250.45 y quedara en 1250.45
        '
        ' Aunque no se arreglar un nmero errneo:
        ' si el signo decimal es la coma:
        '   1,250,45 ser lo mismo que 1,25
        '   12,500.25 ser lo mismo que 12,50
        ' si el signo decimal es el punto:
        '   1.250.45 ser lo mismo que 1.25
        '   12.500,25 ser lo mismo que 12.50
        '
        i = 1
        Do
            i = InStr(i, strNum, sDecimalNo)
            If i Then
                j = j - 1
                If j = 0 Then
                    Mid$(strNum, i, 1) = sDecimal
                Else
                    Mid$(strNum, i, 1) = " "
                End If
                i = i + 1
            End If
        Loop While i
    End If
    
    j = 0
    ' Quitar los espacios que haya por medio
    Do
        i = InStr(strNum, " ")
        If i = 0 Then Exit Do
        strNum = Left$(strNum, i - 1) & Mid$(strNum, i + 1)
    Loop
    
    ConvDecimal = strNum
End Function

Private Sub Class_Terminate()
    Erase aVariables
    Erase aFunctions
End Sub

Public Sub ShowFunctions(aList As Variant)
    '------------------------------------------------------------------------------
    ' Devuelve las funciones y las frmulas usadas en el formato:
    '   Nombre = Funcin | Parmentros
    ' El parmetro indicar una coleccin o un ListBox/ComboBox
    '------------------------------------------------------------------------------
    Dim i As Long
    
    For i = 1 To UBound(aFunctions)
        With aFunctions(i)
            If TypeOf aList Is Collection Then
                aList.Add .Name & " = " & .Formula & " | " & .Params
            Else
                aList.AddItem .Name & " = " & .Formula & " | " & .Params
            End If
        End With
    Next
End Sub

Public Sub ShowVariables(aList As Variant)
    '------------------------------------------------------------------------------
    ' Devuelve las variables y los valores en el formato:
    '   Nombre = Valor
    ' El parmetro indicar una coleccin o un ListBox/ComboBox
    '------------------------------------------------------------------------------
    Dim i As Long
    
    For i = 1 To UBound(aVariables)
        If TypeOf aList Is Collection Then
            aList.Add aVariables(i).Name & " = " & aVariables(i).Value
        Else
            aList.AddItem aVariables(i).Name & " = " & aVariables(i).Value
        End If
    Next
End Sub

Public Function Formula(ByVal sExpresion As String) As String
    '------------------------------------------------------------------------------
    ' Esta funcin calcula directamente la expresin
    '------------------------------------------------------------------------------
    ' Comprobar si hay asignaciones en la expresin
    sExpresion = AsignarVariables(sExpresion, Chr$(34))
    ' Interpretar la expresin
    sExpresion = ParseFormula(sExpresion)
    ' Calcular la expresin
    Formula = Calcular(sExpresion)
End Function

Public Function IsFuncOrVar(ByVal sName As String) As Boolean
    '------------------------------------------------------------------------------
    ' Comprobar si es una funcin o variable
    
    ' Es importante comprobar primero las funciones
    ' para que no se aada una funcin como si fuese una variable no declarada
    '------------------------------------------------------------------------------
    ' Si no es un nmero
    If Not IsNumeric(sName) Then
        If IsFunction(sName) Then
            IsFuncOrVar = True
        ElseIf IsVariable(sName) Then
            IsFuncOrVar = True
        End If
    End If
End Function

Private Function Parametros(ByRef sExp As String) As String
    '------------------------------------------------------------------------------
    ' Devolver los parmetros de la expresin pasada por referencia    (08/Feb/99)
    ' Los parmetros deben estar encerrados entre parntesis
    ' En sExp, se devolver el resto de la cadena.
    '------------------------------------------------------------------------------
    Dim i           As Long
    Dim j           As Long
    Dim k           As Long
    Dim sParams     As String
    Dim sExpAnt     As String
    '
    sExp = Trim$(sExp)
    sExpAnt = sExp
    '
    '
    ' Buscarlos, estarn entre parntesis
    '
    If Left$(sExp, 1) = "(" Then
        sExp = Mid$(sExp, 2)
        ' Buscar el siguiente )
        k = 0
        j = 0
        For i = 1 To Len(sExp)
            If Mid$(sExp, i, 1) = "(" Then
                j = j + 1
            End If
            If Mid$(sExp, i, 1) = ")" Then
                j = j - 1
                If j = -1 Then
                    k = i
                    Exit For
                End If
            End If
        Next
        If k Then
            sParams = Left$(sExp, k - 1)
            sExp = Mid$(sExp, k + 1)
        End If
    Else
        sParams = ""
        sExp = sExpAnt
    End If
    Parametros = sParams
End Function
